Open CASCADE Technology: BVH_ObjectSet< T, N > Class Template Reference

Open CASCADE Technology 6.9.1

- Main Page
- Related Pages
- Namespaces
- Data Structures
- Files

- Data Structures
- Data Structure Index
- Class Hierarchy
- Data Fields

Public Types | Public Member Functions | Protected Attributes
BVH_ObjectSet< T, N > Class Template Reference

Array of abstract entities (bounded by BVH boxes) to built BVH. More...

`#include <BVH_ObjectSet.hxx>`

Inheritance diagram for BVH_ObjectSet< T, N >:
[legend]

## Public Types
typedef NCollection_Vector< NCollection_Handle< BVH_Object< T, N > > > | BVH_ObjectList
| Type of array of geometric objects. More...
Public Types inherited from BVH_Set< T, N >
typedef BVH_Box< T, N > | BVH_BoxNt

## Public Member Functions
| BVH_ObjectSet ()
| Creates new set of geometric objects. More...
virtual | ~BVH_ObjectSet ()
| Releases resources of set of geometric objects. More...
virtual void | Clear ()
| Removes all geometric objects. More...
BVH_ObjectList & | Objects ()
| Returns reference to the array of geometric objects. More...
const BVH_ObjectList & | Objects () const
| Returns reference to the array of geometric objects. More...
virtual Standard_Integer | Size () const
| Return total number of objects. More...
virtual BVH_Box< T, N > | Box (const Standard_Integer theIndex) const
| Returns AABB of the given object. More...
virtual T | Center (const Standard_Integer theIndex, const Standard_Integer theAxis) const
| Returns centroid position along the given axis. More...
virtual void | Swap (const Standard_Integer theIndex1, const Standard_Integer theIndex2)
| Performs transposing the two given objects in the set. More...
Public Member Functions inherited from BVH_Set< T, N >
| BVH_Set ()
| Creates new abstract set of objects. More...
virtual | ~BVH_Set ()=0
| Releases resources of set of objects. More...
virtual BVH_Box< T, N > | Box () const
| Returns AABB of the entire set of objects. More...

## Protected Attributes
BVH_ObjectList | myObjects
| Array of geometric objects. More...

## Detailed Description

### template<class T, int N>
class BVH_ObjectSet< T, N >

Array of abstract entities (bounded by BVH boxes) to built BVH.

Template Parameters

  T | Numeric data type
  N | Vector dimension

## Member Typedef Documentation

template<class T, int N>

typedef NCollection_Vector<NCollection_Handle<BVH_Object<T, N> > > BVH_ObjectSet< T, N >::BVH_ObjectList

Type of array of geometric objects.

## Constructor & Destructor Documentation

template<class T, int N>

BVH_ObjectSet< T, N >::BVH_ObjectSet | ( |  | ) |

Creates new set of geometric objects.

template<class T, int N>

virtual BVH_ObjectSet< T, N >::~BVH_ObjectSet | ( |  | ) |
| virtual

Releases resources of set of geometric objects.

## Member Function Documentation

template<class T, int N>

virtual BVH_Box<T, N> BVH_ObjectSet< T, N >::Box | ( | const Standard_Integer | theIndex | ) | const
| virtual

Returns AABB of the given object.

Implements BVH_Set< T, N >.

template<class T, int N>

virtual T BVH_ObjectSet< T, N >::Center | ( | const Standard_Integer | theIndex,
|  | const Standard_Integer | theAxis
| ) |  | const
| virtual

Returns centroid position along the given axis.

Implements BVH_Set< T, N >.

template<class T, int N>

virtual void BVH_ObjectSet< T, N >::Clear | ( |  | ) |
| virtual

Removes all geometric objects.

Reimplemented in OpenGl_RaytraceGeometry.

template<class T, int N>

BVH_ObjectList& BVH_ObjectSet< T, N >::Objects | ( |  | ) |

Returns reference to the array of geometric objects.

template<class T, int N>

const BVH_ObjectList& BVH_ObjectSet< T, N >::Objects | ( |  | ) | const

Returns reference to the array of geometric objects.

template<class T, int N>

virtual Standard_Integer BVH_ObjectSet< T, N >::Size | ( |  | ) | const
| virtual

Return total number of objects.

Implements BVH_Set< T, N >.

template<class T, int N>

virtual void BVH_ObjectSet< T, N >::Swap | ( | const Standard_Integer | theIndex1,
|  | const Standard_Integer | theIndex2
| ) |  |
| virtual

Performs transposing the two given objects in the set.

Implements BVH_Set< T, N >.

## Field Documentation

template<class T, int N>

BVH_ObjectList BVH_ObjectSet< T, N >::myObjects
| protected

Array of geometric objects.

The documentation for this class was generated from the following file:

- BVH_ObjectSet.hxx